import React, { useState, useCallback, useEffect } from 'react';
import ReactDOM from 'react-dom';
import {csv} from 'd3';
import {message} from './message';

const csvUrl = "https://gist.githubusercontent.com/minwoopak/89107ac877ff2cb1741dfe08d91591d5/raw/cssNamedColors.csv";

const App = () => {
  const [data, setData] = useState(null);
  /*
  useEffect hook is needed whenever we do a side_effect(network request like fetching data).
  It lets you perform that side_effect only once (only when the data changes. But the data doesn't change here).
  Even if we don't change state, we use it since that data is accessible directly within the component
  */
  useEffect(()=>{
    csv(csvUrl).then(setData);
  }, [])
  
  return <pre>{data ? message(data) : 'Loading...'}</pre>;
};

const rootElement = document.getElementById("root");
ReactDOM.render(<App />, rootElement);
